diff --git a/database/db.go b/database/db.go
index ef5bf2f3..92fca27a 100644
--- a/database/db.go
+++ b/database/db.go
@@ -8,6 +8,7 @@ import (
 	"os"
 	"path"
 	"x-ui/config"
+	"x-ui/xray"
 	"x-ui/database/model"
 )
 
@@ -43,6 +44,9 @@ func initSetting() error {
 func initInboundClientIps() error {
 	return db.AutoMigrate(&model.InboundClientIps{})
 }
+func initClientTraffic() error {
+	return db.AutoMigrate(&xray.ClientTraffic{})
+}
 
 func InitDB(dbPath string) error {
 	dir := path.Dir(dbPath)
@@ -83,7 +87,11 @@ func InitDB(dbPath string) error {
 	if err != nil {
 		return err
 	}
-
+	err = initClientTraffic()
+	if err != nil {
+		return err
+	}
+	
 	return nil
 }
 
diff --git a/database/model/model.go b/database/model/model.go
index 987083a8..30e348be 100644
--- a/database/model/model.go
+++ b/database/model/model.go
@@ -32,6 +32,7 @@ type Inbound struct {
 	Remark     string `json:"remark" form:"remark"`
 	Enable     bool   `json:"enable" form:"enable"`
 	ExpiryTime int64  `json:"expiryTime" form:"expiryTime"`
+    ClientStats []xray.ClientTraffic  `gorm:"foreignKey:InboundId;references:Id" json:"clientStats" form:"clientStats"`
 
 	// config part
 	Listen         string   `json:"listen" form:"listen"`
@@ -75,4 +76,6 @@ type Client struct {
 	Email string `json:"email"`
 	LimitIP int `json:"limitIp"`
 	Security string `json:"security"`
-}
+	TotalGB      int64  `json:"totalGB" form:"totalGB"`
+	ExpiryTime int64  `json:"expiryTime" form:"expiryTime"`
+}
\ No newline at end of file
diff --git a/web/assets/js/model/models.js b/web/assets/js/model/models.js
index d15afdc6..768bf4de 100644
--- a/web/assets/js/model/models.js
+++ b/web/assets/js/model/models.js
@@ -44,7 +44,7 @@ class DBInbound {
         this.streamSettings = "";
         this.tag = "";
         this.sniffing = "";
-
+        this.clientStats = ""
         if (data == null) {
             return;
         }
@@ -125,6 +125,7 @@ class DBInbound {
         if (!ObjectUtil.isEmpty(this.sniffing)) {
             sniffing = JSON.parse(this.sniffing);
         }
+
         const config = {
             port: this.port,
             listen: this.listen,
@@ -133,6 +134,7 @@ class DBInbound {
             streamSettings: streamSettings,
             tag: this.tag,
             sniffing: sniffing,
+            clientStats: this.clientStats,
         };
         return Inbound.fromJson(config);
     }
diff --git a/web/assets/js/model/xray.js b/web/assets/js/model/xray.js
index cb15842b..79843b4f 100644
--- a/web/assets/js/model/xray.js
+++ b/web/assets/js/model/xray.js
@@ -608,6 +608,7 @@ class Inbound extends XrayCommonClass {
                 streamSettings=new StreamSettings(),
                 tag='',
                 sniffing=new Sniffing(),
+                clientStats='',
                 ) {
         super();
         this.port = port;
@@ -617,6 +618,10 @@ class Inbound extends XrayCommonClass {
         this.stream = streamSettings;
         this.tag = tag;
         this.sniffing = sniffing;
+        this.clientStats = clientStats;
+    }
+    getClientStats() {
+        return this.clientStats;
     }
 
     get protocol() {
@@ -810,6 +815,21 @@ class Inbound extends XrayCommonClass {
         return this.stream.grpc.serviceName;
     }
 
+    isExpiry(index) {
+        switch (this.protocol) {
+            case Protocols.VMESS:
+                if(this.settings.vmesses[index]._expiryTime != null)
+                    return this.settings.vmesses[index]._expiryTime < new Date().getTime();
+                return false
+            case Protocols.VLESS:
+                if(this.settings.vlesses[index]._expiryTime != null)
+                    return this.settings.vlesses[index]._expiryTime < new Date().getTime();
+                return false
+            default:
+                return false;
+        }
+    }
+
     canEnableTls() {
         switch (this.protocol) {
             case Protocols.VMESS:
@@ -1055,6 +1075,7 @@ class Inbound extends XrayCommonClass {
             StreamSettings.fromJson(json.streamSettings),
             json.tag,
             Sniffing.fromJson(json.sniffing),
+            json.clientStats
         )
     }
 
@@ -1071,6 +1092,7 @@ class Inbound extends XrayCommonClass {
             streamSettings: streamSettings,
             tag: this.tag,
             sniffing: this.sniffing.toJson(),
+            clientStats: this.clientStats
         };
     }
 }
@@ -1157,13 +1179,14 @@ Inbound.VmessSettings = class extends Inbound.Settings {
     }
 };
 Inbound.VmessSettings.Vmess = class extends XrayCommonClass {
-    constructor(id=RandomUtil.randomUUID(), alterId=0, email='', limitIp=0) {
+    constructor(id=RandomUtil.randomUUID(), alterId=0, email='', limitIp=0, totalGB=0, expiryTime='') {
         super();
         this.id = id;
         this.alterId = alterId;
         this.email = email;
         this.limitIp = limitIp;
-
+        this.totalGB = totalGB;
+        this.expiryTime = expiryTime;
     }
 
     static fromJson(json={}) {
@@ -1172,9 +1195,33 @@ Inbound.VmessSettings.Vmess = class extends XrayCommonClass {
             json.alterId,
             json.email,
             json.limitIp,
+            json.totalGB,
+            json.expiryTime,
 
         );
     }
+    get _expiryTime() {
+        if (this.expiryTime === 0 || this.expiryTime === "") {
+            return null;
+        }
+        return moment(this.expiryTime);
+    }
+
+    set _expiryTime(t) {
+        if (t == null || t === "") {
+            this.expiryTime = 0;
+        } else {
+            this.expiryTime = t.valueOf();
+        }
+    }
+    get _totalGB() {
+        return toFixed(this.totalGB / ONE_GB, 2);
+    }
+
+    set _totalGB(gb) {
+        this.totalGB = toFixed(gb * ONE_GB, 0);
+    }
+
 };
 
 Inbound.VLESSSettings = class extends Inbound.Settings {
@@ -1212,15 +1259,19 @@ Inbound.VLESSSettings = class extends Inbound.Settings {
             fallbacks: Inbound.VLESSSettings.toJsonArray(this.fallbacks),
         };
     }
+
 };
 Inbound.VLESSSettings.VLESS = class extends XrayCommonClass {
 
-    constructor(id=RandomUtil.randomUUID(), flow=FLOW_CONTROL.DIRECT, email='', limitIp=0) {
+    constructor(id=RandomUtil.randomUUID(), flow=FLOW_CONTROL.DIRECT, email='', limitIp=0, totalGB=0, expiryTime='') {
         super();
         this.id = id;
         this.flow = flow;
         this.email = email;
         this.limitIp = limitIp;
+        this.totalGB = totalGB;
+        this.expiryTime = expiryTime;
+
     }
 
     static fromJson(json={}) {
@@ -1228,9 +1279,34 @@ Inbound.VLESSSettings.VLESS = class extends XrayCommonClass {
             json.id,
             json.flow,
             json.email,
-            json.limitIp
+            json.limitIp,
+            json.totalGB,
+            json.expiryTime,
+
         );
     }
+
+    get _expiryTime() {
+        if (this.expiryTime === 0 || this.expiryTime === "") {
+            return null;
+        }
+        return moment(this.expiryTime);
+    }
+
+    set _expiryTime(t) {
+        if (t == null || t === "") {
+            this.expiryTime = 0;
+        } else {
+            this.expiryTime = t.valueOf();
+        }
+    }
+    get _totalGB() {
+        return toFixed(this.totalGB / ONE_GB, 2);
+    }
+
+    set _totalGB(gb) {
+        this.totalGB = toFixed(gb * ONE_GB, 0);
+    }
 };
 Inbound.VLESSSettings.Fallback = class extends XrayCommonClass {
     constructor(name="", alpn='', path='', dest='', xver=0) {
diff --git a/web/job/check_inbound_job.go b/web/job/check_inbound_job.go
index 14883023..2b24afb0 100644
--- a/web/job/check_inbound_job.go
+++ b/web/job/check_inbound_job.go
@@ -15,7 +15,15 @@ func NewCheckInboundJob() *CheckInboundJob {
 }
 
 func (j *CheckInboundJob) Run() {
-	count, err := j.inboundService.DisableInvalidInbounds()
+	count, err := j.inboundService.DisableInvalidClients()
+	if err != nil {
+		logger.Warning("disable invalid Client err:", err)
+	} else if count > 0 {
+		logger.Debugf("disabled %v Client", count)
+		j.xrayService.SetToNeedRestart()
+	}
+
+	count, err = j.inboundService.DisableInvalidInbounds()
 	if err != nil {
 		logger.Warning("disable invalid inbounds err:", err)
 	} else if count > 0 {
diff --git a/web/job/xray_traffic_job.go b/web/job/xray_traffic_job.go
index 22e1bb7b..fa0fa636 100644
--- a/web/job/xray_traffic_job.go
+++ b/web/job/xray_traffic_job.go
@@ -18,6 +18,19 @@ func (j *XrayTrafficJob) Run() {
 	if !j.xrayService.IsXrayRunning() {
 		return
 	}
+
+	// get Client Traffic
+
+	clientTraffics, err := j.xrayService.GetXrayClientTraffic()
+	if err != nil {
+		logger.Warning("get xray client traffic failed:", err)
+		return
+	}
+	err = j.inboundService.AddClientTraffic(clientTraffics)
+	if err != nil {
+		logger.Warning("add client traffic failed:", err)
+	}
+	
 	traffics, err := j.xrayService.GetXrayTraffic()
 	if err != nil {
 		logger.Warning("get xray traffic failed:", err)
@@ -27,4 +40,7 @@ func (j *XrayTrafficJob) Run() {
 	if err != nil {
 		logger.Warning("add traffic failed:", err)
 	}
+	
+
+
 }
diff --git a/web/service/inbound.go b/web/service/inbound.go
index d5a685a8..7dbeb272 100644
--- a/web/service/inbound.go
+++ b/web/service/inbound.go
@@ -4,6 +4,7 @@ import (
 	"fmt"
 	"time"
 	"x-ui/database"
+	"encoding/json"
 	"x-ui/database/model"
 	"x-ui/util/common"
 	"x-ui/xray"
@@ -17,7 +18,7 @@ type InboundService struct {
 func (s *InboundService) GetInbounds(userId int) ([]*model.Inbound, error) {
 	db := database.GetDB()
 	var inbounds []*model.Inbound
-	err := db.Model(model.Inbound{}).Where("user_id = ?", userId).Find(&inbounds).Error
+	err := db.Model(model.Inbound{}).Preload("ClientStats").Where("user_id = ?", userId).Find(&inbounds).Error
 	if err != nil && err != gorm.ErrRecordNotFound {
 		return nil, err
 	}
@@ -27,7 +28,7 @@ func (s *InboundService) GetInbounds(userId int) ([]*model.Inbound, error) {
 func (s *InboundService) GetAllInbounds() ([]*model.Inbound, error) {
 	db := database.GetDB()
 	var inbounds []*model.Inbound
-	err := db.Model(model.Inbound{}).Find(&inbounds).Error
+	err := db.Model(model.Inbound{}).Preload("ClientStats").Find(&inbounds).Error
 	if err != nil && err != gorm.ErrRecordNotFound {
 		return nil, err
 	}
@@ -57,8 +58,12 @@ func (s *InboundService) AddInbound(inbound *model.Inbound) (*model.Inbound,erro
 		return inbound, common.NewError("端口已存在:", inbound.Port)
 	}
 	db := database.GetDB()
-	
-	return inbound, db.Save(inbound).Error
+
+	err = db.Save(inbound).Error
+	if err == nil {
+		s.UpdateClientStat(inbound.Id,inbound.Settings)
+	}
+	return inbound, err
 }
 
 func (s *InboundService) AddInbounds(inbounds []*model.Inbound) error {
@@ -135,6 +140,7 @@ func (s *InboundService) UpdateInbound(inbound *model.Inbound) (*model.Inbound,
 	oldInbound.Sniffing = inbound.Sniffing
 	oldInbound.Tag = fmt.Sprintf("inbound-%v", inbound.Port)
 
+	s.UpdateClientStat(inbound.Id,inbound.Settings)
 	db := database.GetDB()
 	return inbound, db.Save(oldInbound).Error
 }
@@ -166,6 +172,54 @@ func (s *InboundService) AddTraffic(traffics []*xray.Traffic) (err error) {
 	}
 	return
 }
+func (s *InboundService) AddClientTraffic(traffics []*xray.ClientTraffic) (err error) {
+	if len(traffics) == 0 {
+		return nil
+	}
+	db := database.GetDB()
+	db = db.Model(xray.ClientTraffic{})
+	tx := db.Begin()
+	defer func() {
+		if err != nil {
+			tx.Rollback()
+		} else {
+			tx.Commit()
+		}
+	}()
+	for _, traffic := range traffics {
+		inbound := &model.Inbound{}
+
+		err := db.Model(model.Inbound{}).Where("settings like ?", "%" + traffic.Email + "%").First(inbound).Error
+		traffic.InboundId = inbound.Id
+		if err != nil {
+			return err
+		}
+		// get settings clients
+		settings := map[string][]model.Client{}
+		json.Unmarshal([]byte(inbound.Settings), &settings)
+		clients := settings["clients"]
+		for _, client := range clients {
+			if traffic.Email == client.Email {
+				traffic.ExpiryTime = client.ExpiryTime
+				traffic.Total = client.TotalGB
+			}
+		}
+		if tx.Where("inbound_id = ?", inbound.Id).Where("email = ?", traffic.Email).
+		UpdateColumn("enable", true).
+		UpdateColumn("expiry_time", traffic.ExpiryTime).
+		UpdateColumn("total",traffic.Total).
+		UpdateColumn("up", gorm.Expr("up + ?", traffic.Up)).
+		UpdateColumn("down", gorm.Expr("down + ?", traffic.Down)).RowsAffected == 0 {
+			err = tx.Create(traffic).Error
+		}
+		
+		if err != nil {
+			return err
+		}
+	
+	}
+	return
+}
 
 func (s *InboundService) DisableInvalidInbounds() (int64, error) {
 	db := database.GetDB()
@@ -177,6 +231,46 @@ func (s *InboundService) DisableInvalidInbounds() (int64, error) {
 	count := result.RowsAffected
 	return count, err
 }
+func (s *InboundService) DisableInvalidClients() (int64, error) {
+	db := database.GetDB()
+	now := time.Now().Unix() * 1000
+	result := db.Model(xray.ClientTraffic{}).
+		Where("((total > 0 and up + down >= total) or (expiry_time > 0 and expiry_time <= ?)) and enable = ?", now, true).
+		Update("enable", false)
+	err := result.Error
+	count := result.RowsAffected
+	return count, err
+}
+func (s *InboundService) UpdateClientStat(inboundId int, inboundSettings string) (error) {
+	db := database.GetDB()
+
+	// get settings clients
+	settings := map[string][]model.Client{}
+	json.Unmarshal([]byte(inboundSettings), &settings)
+	clients := settings["clients"]
+	for _, client := range clients {
+		result := db.Model(xray.ClientTraffic{}).
+		Where("inbound_id = ? and email = ?", inboundId, client.Email).
+		Updates(map[string]interface{}{"enable": true, "total": client.TotalGB, "expiry_time": client.ExpiryTime})
+		if result.RowsAffected == 0 {
+			clientTraffic := xray.ClientTraffic{}
+			clientTraffic.InboundId = inboundId
+			clientTraffic.Email = client.Email
+			clientTraffic.Total = client.TotalGB
+			clientTraffic.ExpiryTime = client.ExpiryTime
+			clientTraffic.Enable = true
+			clientTraffic.Up = 0
+			clientTraffic.Down = 0
+			db.Create(&clientTraffic)
+		}
+		err := result.Error
+		if err != nil {
+			return err
+		}
+	
+	}
+	return nil
+}
 
 func (s *InboundService) GetInboundClientIps(clientEmail string) (string, error) {
 	db := database.GetDB()
diff --git a/web/service/xray.go b/web/service/xray.go
index 7cfb909c..4a062f16 100644
--- a/web/service/xray.go
+++ b/web/service/xray.go
@@ -6,7 +6,6 @@ import (
 	"sync"
 	"x-ui/logger"
 	"x-ui/xray"
-
 	"go.uber.org/atomic"
 )
 
@@ -51,6 +50,9 @@ func (s *XrayService) GetXrayVersion() string {
 	}
 	return p.GetVersion()
 }
+func RemoveIndex(s []interface{}, index int) []interface{} {
+	return append(s[:index], s[index+1:]...)
+}
 
 func (s *XrayService) GetXrayConfig() (*xray.Config, error) {
 	templateConfig, err := s.settingService.GetXrayConfigTemplate()
@@ -64,6 +66,8 @@ func (s *XrayService) GetXrayConfig() (*xray.Config, error) {
 		return nil, err
 	}
 
+	s.inboundService.DisableInvalidClients()
+
 	inbounds, err := s.inboundService.GetAllInbounds()
 	if err != nil {
 		return nil, err
@@ -72,6 +76,40 @@ func (s *XrayService) GetXrayConfig() (*xray.Config, error) {
 		if !inbound.Enable {
 			continue
 		}
+		// get settings clients
+		settings := map[string]interface{}{}
+		json.Unmarshal([]byte(inbound.Settings), &settings)
+		clients :=  settings["clients"].([]interface{})
+	
+
+
+		// check users active or not
+
+		clientStats := inbound.ClientStats
+		for _, clientTraffic := range clientStats {
+			
+			for index, client := range clients {
+				c := client.(map[string]interface{})
+				if c["email"] == clientTraffic.Email {
+					if ! clientTraffic.Enable {
+						clients = RemoveIndex(clients,index)
+						logger.Info("Remove Inbound User",c["email"] ,"due the expire or traffic limit")
+
+					}
+
+				}
+			}
+	
+
+		}
+		settings["clients"] = clients
+		modifiedSettings, err := json.Marshal(settings)
+		if err != nil {
+			return nil, err
+		}
+	
+		inbound.Settings = string(modifiedSettings)
+
 		inboundConfig := inbound.GenXrayInboundConfig()
 		xrayConfig.InboundConfigs = append(xrayConfig.InboundConfigs, *inboundConfig)
 	}
@@ -84,6 +122,12 @@ func (s *XrayService) GetXrayTraffic() ([]*xray.Traffic, error) {
 	}
 	return p.GetTraffic(true)
 }
+func (s *XrayService) GetXrayClientTraffic() ([]*xray.ClientTraffic, error) {
+	if !s.IsXrayRunning() {
+		return nil, errors.New("xray is not running")
+	}
+	return p.GetClientTraffic(false)
+}
 
 func (s *XrayService) RestartXray(isForce bool) error {
 	lock.Lock()
diff --git a/xray/client_traffic.go b/xray/client_traffic.go
new file mode 100644
index 00000000..4df6a502
--- /dev/null
+++ b/xray/client_traffic.go
@@ -0,0 +1,12 @@
+package xray
+
+type ClientTraffic struct {
+	Id  int `json:"id" form:"id" gorm:"primaryKey;autoIncrement"`
+	InboundId int `json:"inboundId" form:"inboundId"`
+	Enable     bool   `json:"enable" form:"enable"`
+	Email       string `json:"email" form:"email" gorm:"unique"`
+	Up        int64 `json:"up" form:"up"`
+	Down      int64 `json:"down" form:"down"`
+	ExpiryTime int64  `json:"expiryTime" form:"expiryTime"`
+	Total      int64  `json:"total" form:"total"`
+}
diff --git a/xray/process.go b/xray/process.go
index 7d0d2d05..16d8a270 100644
--- a/xray/process.go
+++ b/xray/process.go
@@ -22,6 +22,7 @@ import (
 )
 
 var trafficRegex = regexp.MustCompile("(inbound|outbound)>>>([^>]+)>>>traffic>>>(downlink|uplink)")
+var ClientTrafficRegex = regexp.MustCompile("(user)>>>([^>]+)>>>traffic>>>(downlink|uplink)")
 
 func GetBinaryName() string {
 	return fmt.Sprintf("xray-%s-%s", runtime.GOOS, runtime.GOARCH)
@@ -253,6 +254,9 @@ func (p *process) GetTraffic(reset bool) ([]*Traffic, error) {
 	traffics := make([]*Traffic, 0)
 	for _, stat := range resp.GetStat() {
 		matchs := trafficRegex.FindStringSubmatch(stat.Name)
+		if len(matchs) < 3 {
+			continue
+		}
 		isInbound := matchs[1] == "inbound"
 		tag := matchs[2]
 		isDown := matchs[3] == "downlink"
@@ -277,3 +281,53 @@ func (p *process) GetTraffic(reset bool) ([]*Traffic, error) {
 
 	return traffics, nil
 }
+func (p *process) GetClientTraffic(reset bool) ([]*ClientTraffic, error) {
+	if p.apiPort == 0 {
+		return nil, common.NewError("xray api port wrong:", p.apiPort)
+	}
+	conn, err := grpc.Dial(fmt.Sprintf("127.0.0.1:%v", p.apiPort), grpc.WithInsecure())
+	if err != nil {
+		return nil, err
+	}
+	defer conn.Close()
+
+	client := statsservice.NewStatsServiceClient(conn)
+	ctx, cancel := context.WithTimeout(context.Background(), time.Second*10)
+	defer cancel()
+	request := &statsservice.QueryStatsRequest{
+		Reset_: reset,
+	}
+	resp, err := client.QueryStats(ctx, request)
+	if err != nil {
+		return nil, err
+	}
+	emailTrafficMap := map[string]*ClientTraffic{}
+	traffics := make([]*ClientTraffic, 0)
+	for _, stat := range resp.GetStat() {
+		matchs := ClientTrafficRegex.FindStringSubmatch(stat.Name)
+		if len(matchs) < 3 {
+			continue
+		}
+		isUser := matchs[1] == "user"
+		email := matchs[2]
+		isDown := matchs[3] == "downlink"
+		if ! isUser {
+			continue
+		}
+		traffic, ok := emailTrafficMap[email]
+		if !ok {
+			traffic = &ClientTraffic{
+				Email:       email,
+			}
+			emailTrafficMap[email] = traffic
+			traffics = append(traffics, traffic)
+		}
+		if isDown {
+			traffic.Down = stat.Value
+		} else {
+			traffic.Up = stat.Value
+		}
+	}
+
+	return traffics, nil
+}
